unit SeveralAETPD7_IMPL;

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, Office2000, adxAddIn, SeveralAETPD7_TLB, StdVcl,
  Classes, adxxlFormsManager;

type
  TCoSeveralAETPD7 = class(TadxAddin, ICoSeveralAETPD7)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    adxExcelTaskPanesManager1: TadxExcelTaskPanesManager;
    procedure adxCOMAddInModuleAddInStartupComplete(Sender: TObject);
  private
    function GetTaskPane(Item: TadxExcelTaskPanesCollectionItem; ShouldBeVisible: boolean; ShouldBeActive: boolean): TadxExcelTaskPane;
    function GetVisibleAndActiveTaskPane: TadxExcelTaskPane;
    procedure ActivateTaskPane(TaskPane: TadxExcelTaskPane);
  protected
  public
    procedure UpdateControllingForm(ActiveTaskPane: TadxExcelTaskPane);
    procedure ActivateADXExcelTaskPane1;
    procedure ActivateADXExcelTaskPane2;
  end;

implementation

uses uControllingTaskPane, Unit1, Unit2;

{$R *.dfm}

{ TAddInModule }

procedure TAddInModule.ActivateADXExcelTaskPane1;
begin
  ActivateTaskPane(adxExcelTaskPanesManager1.Items[1].TaskPaneInstance);
end;

procedure TAddInModule.ActivateADXExcelTaskPane2;
begin
  ActivateTaskPane(adxExcelTaskPanesManager1.Items[2].TaskPaneInstance);
end;

procedure TAddInModule.ActivateTaskPane(TaskPane: TadxExcelTaskPane);
begin
  if (TaskPane <> nil) then begin
    TaskPane.Activate;
  end;
end;

function TAddInModule.GetTaskPane(Item: TadxExcelTaskPanesCollectionItem;
  ShouldBeVisible, ShouldBeActive: boolean): TadxExcelTaskPane;
var
  TaskPane: TadxExcelTaskPane;
begin
  result := nil;
  TaskPane := Item.TaskPaneInstance;
  if (TaskPane <> nil) then begin
    if ((ShouldBeVisible and TaskPane.Visible or (not ShouldBeVisible and not TaskPane.Visible))
        and (ShouldBeActive and TaskPane.Active or (not ShouldBeActive and not TaskPane.Active))) then begin
      result := TaskPane;
      exit;
    end;
  end;
end;

function TAddInModule.GetVisibleAndActiveTaskPane: TadxExcelTaskPane;
var
  TaskPane: TadxExcelTaskPane;
begin
  result := nil;

  TaskPane := GetTaskPane(adxExcelTaskPanesManager1.Items[1], true, true);

  if (TaskPane <> nil) then begin
    result := TaskPane;
    exit;
  end;

  TaskPane := GetTaskPane(adxExcelTaskPanesManager1.Items[2], true, true);

  if (TaskPane <> nil) then begin
    result := TaskPane;
    exit;
  end;

end;

procedure TAddInModule.UpdateControllingForm(
  ActiveTaskPane: TadxExcelTaskPane);
begin
  if (adxExcelTaskPanesManager1.Items[0].TaskPaneInstance <> nil) then begin
    (adxExcelTaskPanesManager1.Items[0].TaskPaneInstance as TControllingTaskPane).ApplyActiveTaskPane(ActiveTaskPane);
  end;
end;

procedure TAddInModule.adxCOMAddInModuleAddInStartupComplete(
  Sender: TObject);
var
  ActiveTaskPane: TadxExcelTaskPane;
begin
  ActiveTaskPane := GetVisibleAndActiveTaskPane();
  UpdateControllingForm(ActiveTaskPane);
end;

initialization
  TadxFactory.Create(ComServer, TCoSeveralAETPD7, CLASS_CoSeveralAETPD7, TAddInModule);

end.
